--[[
-- Copyright (c) 2012  Anton Savoshchanka (aka AntonioModer)
--
-- This software is provided 'as-is', without any express or implied
-- warranty.  In no event will the authors be held liable for any damages
-- arising from the use of this software.
--
-- Permission is granted to anyone to use this software for any purpose,
-- including commercial applications, and to alter it and redistribute it
-- freely, subject to the following restrictions:
--
-- 1. The origin of this software must not be misrepresented; you must not
--    claim that you wrote the original software. If you use this software
--    in a product, an acknowledgment in the product documentation would be
--    appreciated but is not required.
-- 2. Altered source versions must be plainly marked as such, and must not be
--    misrepresented as being the original software.
-- 3. This notice may not be removed or altered from any source distribution.
--]]

--[[
Love_Draw
--]]


function loveDraw()
-- init --
local fps = love.timer.getFPS();


for i, self in pairs(tabClass.Entity) do		
	-- init --
	local physBody = self.physBody;																	-- for speed draw
	local tabDrawColor = self.tabDrawColor;															-- for speed draw
	
	-- draw --
	if self.physShapeType == 1 then
		love.graphics.setColor(tabDrawColor);
		love.graphics.circle("fill", physBody:getX(), physBody:getY(), self.physShape:getRadius());
	end
	if self.physShapeType == 2 then
		love.graphics.setColor(tabDrawColor);
		love.graphics.polygon("fill", physBody:getWorldPoints(self.physShape:getPoints())); 
	end
	if self.physShapeType == 3 then
		love.graphics.setColor(tabDrawColor);
		love.graphics.polygon("fill", physBody:getWorldPoints(self.physShapePoly[1]:getPoints()));
		
		-- love.graphics.setColor(255, 255, 255, 100);													-- white
		-- love.graphics.setPointSize(5);
		-- love.graphics.point(physBody:getWorldCenter());												-- centre of body	
		
		-- love.graphics.setColor(255, 255, 0, 255)	
		-- love.graphics.print( tostring(self.id), physBody:getWorldCenter())	            			-- get id 
	end
	if self.physShapeType == 4 then	
		love.graphics.setColor(tabDrawColor);														-- body color def
		
		-- if mouseGetPhysBody == physBody then														-- if drag body
			-- love.graphics.setColor(253, 205, 126, 255);
		-- end
		
		for tr=1, #self.physShapePoly do
			love.graphics.polygon("fill", physBody:getWorldPoints(self.physShapePoly[tr]:getPoints()));	-- draw body	
		end
		
		-- love.graphics.setColor(0, 255, 255, 255);
		-- for tr=1, #self.physShapePoly do
			-- love.graphics.polygon("line", physBody:getWorldPoints(self.physShapePoly[tr]:getPoints()));	-- draw "line" all triangle of body (draw slow)		
		-- end
		
		-- love.graphics.setColor(255, 255, 255, 100);													-- white
		-- love.graphics.setPointSize(5);
		-- love.graphics.point(physBody:getWorldCenter());												-- centre of body
		
		-- love.graphics.setColor(255, 255, 0, 255)	
		-- love.graphics.print( tostring(self.id), physBody:getWorldCenter())	            			-- get id 
	end	
	

end	-- for

-- Drawing the ray. --
love.graphics.setColor(255, 255, 255, 100)
love.graphics.line(ray1.x1, ray1.y1, ray1.x2, ray1.y2)

-- for i = 1, #ray1.hitList do
	-- local hit = ray1.hitList[i]
	-- love.graphics.setColor(255, 0, 0)
	-- love.graphics.circle("line", hit.x, hit.y, 3)
	-- love.graphics.setColor(255, 255, 0, 255)	
	-- -- love.graphics.print( tostring((hit.fixture:getUserData()).objNameIndex),hit.x, hit.y)	            -- get objNameIndex         	
	-- love.graphics.setColor(0, 255, 0)
	-- love.graphics.line(hit.x, hit.y, hit.x+hit.xn/2, hit.y+hit.yn/2)
-- end

-- draw info --
love.graphics.setCaption("Prototype v revision 0.8.31"..", by AntonioModer".." (mant.base@yandex.ru)", 0, 0);	-- fps in caption
love.graphics.setColor(0, 0, 0);																	-- black

love.graphics.print("FPS = "..fps
	.."\n-1  ".."Press escape to exit."
	.."\n-2  ".."Hold 'ctrl'+'mouse left' - add points ray and slice Body."
	.."\n-3  ".."Hold 'mouse left button' - drag Body."
	-- .."\n-5  ".."mouseX: "..love.mouse.getX()
	-- .."\n-6  ".."mouseY: "..love.mouse.getY()

	, 5, 5);

-- TEST --


end	-- loveDraw()